package bootstrapconfig

type Config struct {
	AntiPhishingCode string `yaml:"anti_phishing_code"`

	Keymap  string
	Modules string

	Auths []Auth

	Networks []struct {
		Name       string
		Interfaces []struct {
			Var     string
			N       int
			Regexps []string
		}
		Script string
	}

	SSH struct {
		Listen string
		Keys   struct {
			DSA     string
			RSA     string
			ECDSA   string
			ED25519 string
		}
	}

	PreLVMCrypt []CryptDev `yaml:"pre_lvm_crypt"`
	LVM         []LvmVG
	Crypt       []CryptDev
	Bootstrap   Bootstrap
}

type Auth struct {
	Name     string
	SSHKey   string `yaml:"sshKey"`
	Password string `yaml:"password"`
}

type LvmVG struct {
	VG  string
	PVs struct {
		N       int
		Regexps []string
	}

	Defaults struct {
		FS   string
		Raid *RaidConfig
	}

	LVs []struct {
		Name    string
		FS      string
		Raid    *RaidConfig
		Size    string
		Extents string
	}
}

type CryptDev struct {
	Dev    string
	Prefix string
	Name   string
}

type RaidConfig struct {
	Mirrors int
	Stripes int
}

type Bootstrap struct {
	Dev  string
	Seed string
}
